// by Lach
// patches Chrispy confetti to make it functional with particle generator things

if ChrispyAssets.HAVE_CONFETTIPARTICLEGEN
	return
end

ChrispyAssets.HAVE_CONFETTIPARTICLEGEN = true

local confetti = {}

local function UpdateConfetti(mo)
	if not mo.valid
		return
	end
		
	local state = mo.state
	
	if state == S_CHRISPY_CONFETTI
	and mo.tics > states[state].tics
		mo.destscale = mo.scale
		mo.state = $
		mo.color = CC_DEFAULT_CONFETTI_COLORS[P_RandomKey(#CC_DEFAULT_CONFETTI_COLORS) + 1]
	end
end

addHook("MapChange", do
	confetti = {}
end)

addHook("NetVars", function(net)
	confetti = net(confetti)
end)

addHook("MobjSpawn", function(mo)
	table.insert(confetti, mo)
end, MT_CHRISPY_CONFETTI)

addHook("ThinkFrame", do
	for i = #confetti, 1, -1
		UpdateConfetti(table.remove(confetti))
	end
end)